#!/usr/bin/perl

use strict;

## DECLARACI DE VARIABLES ##

my $seq1;
my $seq2;
my $matriu;
my $puntuacio_gap;
my @vseq1;
my @vseq2;
my %matdesubstitucio;
my @malin;
my @aliniament;
my @g_esquerra;
my @g_amunt;
my $nom_sequencia1;
my $nom_sequencia2;
my $penalit_obertura;
my $penalit_extensio;

$seq1 = @ARGV [0];                      # entrada del fitxer de la primera seqncia en format FASTA
chomp ($seq1);

$seq2 = @ARGV [1];                      # entrada del fitxer de la segona seqncia en format FASTA
chomp ($seq2);

$matriu = @ARGV [2];                    # entrada del fitxer de la matriu de substituci
chomp ($matriu);
                                                
$penalit_obertura = @ARGV [3];          # entrada de la penalitzaci per obertura de gap
chomp ($penalit_obertura);

if ($penalit_obertura > 0) {            # si la penalitzaci s un valor positiu, el transforma 
    $penalit_obertura = $penalit_obertura * (-1);  # en negatiu per indicar que s penalitzaci
}

$penalit_extensio = @ARGV [4];          # entrada de la penalitzaci per extensi de gap
chomp ($penalit_extensio);

if ($penalit_extensio > 0){                # si la penalitzaci s un valor positiu, el transforma
    $penalit_extensio = $penalit_extensio * (-1);  # en negatiu per indicar que s penalitzaci
}

($seq1,$nom_sequencia1) = llegir_seq($seq1);   # cridem la FUNCIO llegir_seq i recuperem 
                                               #  el resultat en el vectors @vseq1 i tamb el nom 
                                               #  de la seqncia (l'identificador)


my @vseq1 = split (//,$seq1);                  # passem cada lletra de la variable $seq1
                                               #  a una posici del vector @vseq1


unshift(@vseq1,"-");                           # posem  un "gap" al principi de la seqncia 1
                                                

($seq2,$nom_sequencia2) = llegir_seq($seq2);   # cridem una altra vegada la FUNCIO llegir_seq i 
                                               # recuperem tamb vector i identificador

my @vseq2 = split (//,$seq2);                  # passem cada lletra de la variable $seq2
                                               #  a una posici del vector @vseq2

unshift(@vseq2,"-");                           # posem  un "gap" al principi de la seqncia 2


%matdesubstitucio  = llegir_mat($matriu);      # cridem la FUNCIO llegir_mat i recuperem el hash de hashos


                                               #  en %matdesubstitucio


$g_esquerra[0][0][0] = 0;                                                  #inicialitzaci
my $j = 1;                                                                 # de les dues 
while ($j < scalar (@vseq2)){                                              # matrius.
    $g_esquerra[0][$j][0] = $g_esquerra[0][$j-1][0] + $penalit_extensio;   # En la posici 
    $g_amunt[0][$j][0] = $g_esquerra[0][$j][0];    #                      
    $j = $j+1;                                     # [0][0][0] s'inicialitza a 0, per en 
}                                                  #  la primera cella de cada fila i columna >0
                                                   #  s'inicialtza amb el valor que t la matriu 
                                                   #  de puntuacions en aquell punt en lloc de 
$g_amunt[0][0][0] = 0;                             #  inicialitzar-la a 0.
my $j = 1;                                         #
while ($j < scalar (@vseq2)){                      #
    $g_amunt[$j][0][0] = $g_amunt[$j-1][0][0] + $penalit_extensio;    #
    $g_esquerra[$j][0][0] = $g_amunt[$j][0][0];                       #
    $j = $j+1;                                                        #
}                                                                     #
                                                                      #


@malin = constr_malin(\@vseq1,\@vseq2,\%matdesubstitucio,$penalit_obertura,$penalit_extensio); 
                                                           # cridem la funcio constr_malin
                                                           #  utilitzant els parmetres
                                                           #  obtinguts anteriorment 

                                                      
@aliniament = mostra_alin(\@malin,\@vseq1,\@vseq2,\%matdesubstitucio,$nom_sequencia1,$nom_sequencia2);
                   # cridem la funcio mostra_alin utilitzant com a parmetres,
                   #  les dues seqncies, la matriu d'aliniament i els dos identificadors


#####################################      FUNCIONS     ##################################################

# NOM: llegir_seq
# PROPSIT: Donat un fitxer en format FASTA, llegir la seqencia que hi ha i enregistrar-la en un vector
# PARMETRES: fitxer del qual volem llegir la seqencia 
# RETORNA: el vector de la seqncia
sub llegir_seq  {

  my $nom_fitxer_fasta = $_[0];                            # enregistrem en una variable el parmetre
                                                           #  que li hem entrat a la funci
 
  open (SEQUENCIA,"< $nom_fitxer_fasta");                  # obrim un FILEHANDLE per poder llegir
                                                           #  la sequncia

      my $iden = <SEQUENCIA>;                              # llegim la 1a linia del fitxer 
                                                           #  (identificador de la seqncia)  
      chomp($iden);
      my @seql = <SEQUENCIA>;                              # llegim les lnies de la seqncia   
      my $seq  = "";                                       # declarem una variable on hi enregistrarem 
                                                           #  tota la seqncia i la inicialitzem amb 
                                                           #  la paraula buida
                      
  close (SEQUENCIA);                 


  my $i=0;                                                 # declarem una variable per recrrer el vector

  while ($i < scalar(@seql)) {                             #  
       chomp($seql[$i]);                                   # anem recorrent el vector @seq1 per poder
                                                           #  anar enregistrant cada posici del vector
                                                           #  (que ser una linia del fitxer) en la 
       $seq = $seq . $seql[$i];                            #  variable $seq, mitjanant la concatenaci
                                                           #  de smbols
       $i = $i + 1;                                        #
  }                                                        #


  $seq = "\U$seq";                                         # passem totes les lletres (aminocids)
                                                           #  a majscules
                                                                      

  return ($seq,$iden);                                     # retornem les variables que contenen 
                                                           # la sequencia i l'identificador de la seqncia
}
                          

# NOM: llegir_mat
# PROPSIT: Donat un fitxer on hi ha la matriu de substituci, l'enregistrem de 
#           tal manera que ens quedin tots els valors en un hash de hashos
# PARMETRES: fitxer on hi ha enregistrada la matriu de substituci
# RETORNA: retorna el hash de hashos on hi ha els valors de la matriu de substitucio
sub llegir_mat  {

my $nom_fitxer_matriu = $_[0];                # assignem el contingut de la posici 0 del vector annim a una variable

open (MATRIU,"< $nom_fitxer_matriu");         # obrim un FILEHANDLE per poder llegir la matriu

my $linia = 0;                                # declarem  variable  per anar recorrent les files del fitxer  
my $i = 0;                                    # declarem variable per recrrer les diferents posicions tant 
                                              #  del vector @aa com del vector @valors 
 
my @aa;                                       # declarem vector on hi enregistrarem la primera linia
                                              #  de la matriu que contindr tots els aminoacids
 
my %matsubs;                                  # declaraci del hash de hashos


while (<MATRIU>) {
    chomp($_);

    if (!($_ =~ m/\A\#/)) {                             # expressi regular que ens encaixa totes les lnies que 
                                                        #  que no comencin  pel carcter "#"

	if ($_ =~ m/\s*([a-zA-Z][a-zA-Z\D\s]+)/) {      # expressi regular que ens encaixa amb la lnia dels AA
	    @aa = split(/\s+/,$1);
        }

        if ($_ =~ m/\s*([\d\-]+[\-\d\s]+)/) {           # expressi regular que ens encaixa amb totes les lnies
	    my @valors = split(/\s+/,$1);               #  que contenen els valors de la matriu de substituci
            my $i = 0;
            while ($i < scalar(@valors)) {
		$matsubs{$aa[$linia]}{$aa[$i]} = $valors[$i];   # assignem els valors que hem extret del fitxer
		$i = $i + 1;                                    #  en el hash de hashos
	    }
	    $linia = $linia + 1;
	}

    }

}

close(MATRIU);

return %matsubs;                              # retorna el hash de hashos que hem creat dins la funci

}



# NOM: constr_malin
# PROPSIT: Donats diferents parmetres construir la matriu de l'aliniament considerant els valors dels
#            canvis d'aminocids que hi ha en el hash de hashos (obtinguts a partir de la matriu de subs         
# PARMETRES: primer --> vector on hi ha la primera seqncia
#             segon  --> vector on hi ha la segona seqncia
#             tercer --> hash de hashos
#             quart  --> penalitzaci per salt
# RETORNA: la matriu de l'aliniament
sub constr_malin {
my @vector1 = @{$_[0]};                           # 
my @vector2 = @{$_[1]};                           # desreferenciem els parmetres que hem entrat en la funci
my %substitut = %{$_[2]};                         #
my $salt_ob = $_[3];
my $salt_ext = $_[4];                                 
my $un;                                           #
my $dos;                                          # declarem diferents variables que utilitzarem al llarg
my $i;                                            #  de la funci
my $j;                                            #
my @matriupunt;                                   # declarem matriu on enregistrarem tot el resultat de la 
                                                  #  funcio constr_malin


                           
$un= scalar (@vector1);                           # assignem en una variable el numero de simbols dels vectors
$dos= scalar (@vector2);                          # 


my @puntuacions;                                  # declarem matriu dels valors de l'alineament
my @recuperacio;                                  # declarem matriu amb la procedncia dels valors

                                            

$puntuacions[0][0]=0;                             # omplim el valor de la casella [0][0] de les dues matrius
$recuperacio[0][0]="FI";                         #
 
$matriupunt [0][0][0] = $puntuacions [0][0];      # assignem els valors de cada casella de les dues matrius anteriors 
$matriupunt [0][0][1] = $recuperacio [0][0];      #  a una nova matriu amb una tercera dimensi



$j=1;                                                        #
while($j < $dos )                                            #
        {                                                    # omplim la primera fila, que son tots alineaments amb gap, 
                                                             # associant-li una penalitzaci d'extensi de gap i no d'obertura
        $puntuacions[0][$j]=$puntuacions[0][$j-1] + $salt_ext;   #  a ms, anotem d'on procedeix la mxima puntuaci anterior
        $recuperacio[0][$j]='E1';                             #  que en aquest cas sempre es de l'esquerra (E1)
        $matriupunt[0][$j][0] = $puntuacions[0][$j];         #
        $matriupunt[0][$j][1] = $recuperacio[0][$j];         # assignem cada un dels valors anteriors a la tercera dimensi
	$j=$j+1;                                             #  de la matriu final
        }                                                    #

       

$i=1;                                                        # ara anem recorrent la resta de files
while($i < $un )                                             #
        {
        $puntuacions[$i][0] = $puntuacions[$i-1][0] + $salt_ext; 
        $recuperacio[$i][0] = 'A1';                             # en el cas de la primera columna tindrem nomes alineaments amb gap,
                                                                #  associant-li la penalitzaci d'extensi  i no d'obertura
        $matriupunt[$i][0][0] = $puntuacions[$i][0];            #  anotem tamb d'on procedeix la puntuaci, que ara sempre ser 
        $matriupunt[$i][0][1] = $recuperacio[$i][0];            #  d'amunt (A1). Ho assignem a la tercera dimensi 

	$j=1;                                                                                 #
        while($j < $dos )                                                                     # 
                {                                                                             # considerem les 3 
         my $diagonal = $puntuacions[$i-1][$j-1] + $substitut{$vector1[$i]}{$vector2[$j]};    #  possibilitats d'on pot venir la 
        
        
         ($g_amunt[$i][$j][0],$g_amunt[$i][$j][1]) = gaps_amunt($i,$j,\@puntuacions,$salt_ob,$salt_ext,\@g_amunt);  
                                                                              #  puntuaci (diagonal,amunt i esquerra), en les dues ultimes
                                                                              # de les quals ho fem mitjanant una funci
        
         ($g_esquerra[$i][$j][0],$g_esquerra[$i][$j][1]) = gaps_esquerra($i,$j,\@puntuacions,$salt_ob,$salt_ext,\@g_esquerra);       

                                                                           # mirem quina possibilitat de les 3 dna la mxima puntuaci
                
                if (($diagonal >= $g_amunt[$i][$j][0]) && ($diagonal >= $g_esquerra[$i][$j][0])) 
		                                                           #          
                        {                                                  # si s la diagonal, completem la posici de la matriu amb
                        $puntuacions[$i][$j]=$diagonal;                    #  el valor corresponent que hem obtingut al plantejar les
                        $recuperacio[$i][$j] = 'D';                        #  3 possibilitats. Indico d'on prov amb la D
                        }                                                  #

                elsif (($g_amunt[$i][$j][0] >= $diagonal) && ($g_amunt[$i][$j][0] >= $g_esquerra[$i][$j][0]))     #
                        {                                                  # si s la d'amunt, completem la posici de la matriu amb
                        $puntuacions[$i][$j]=$g_amunt[$i][$j][0];          #  el valor corresponent que hem obtingut al plantejar les
                        $recuperacio[$i][$j] = 'A'. $g_amunt[$i][$j][1];   #  3 possibilitats. Indico d'on prov amb la A i li concateno
                                                                           # el numero de salts introduits
                        }                                                  #

                else                                                       #
                        {                                                  # si s la de l'esquerra, completem la posici de la matriu 
                        $puntuacions[$i][$j]= $g_esquerra[$i][$j][0];      #  amb el valor corresponent que hem obtingut al plantejar les
                        $recuperacio[$i][$j]='E'. $g_esquerra[$i][$j][1];  #  3 possibilitats. Indico d'on prov amb la E i
                                                                           # li concateno el numero de salts introduits
                        }                                                  #


                $matriupunt[$i][$j][0] = $puntuacions[$i][$j];             # enregistrem els valors mxims en la tercera dimensi, 
		$matriupunt[$i][$j][1] = $recuperacio[$i][$j];	           #  juntament amb la procedncia del valor i el numero de salts introduits si es el cas
	        $j=$j+1;                                                   
                }                                                          
        $i = $i + 1;                 
    }

    return @matriupunt;                                                    # retornem la matriu de l'aliniament
}

# NOM: mostra_alin
# PROPSIT: Donats uns parmetres, recuperar l'aliniament ptim i mostrar-lo per pantalla com a resultat final, juntament amb la 
#           identitat i la similaritat
# PARMETRES: primer --> matriu de l'aliniament 
#             segon  --> vector amb la seqncia 1
#             tercer --> vector amb la seqncia 2
#             quart  --> hash de hashos amb els valors de la matriu de substituci
#             cinqu --> identificador de la seqncia 1
#             sis   --> identificador de la seqncia 2 
sub mostra_alin {
my @mrecuperacio = @{$_[0]};                    #
my @vseq1 = @{$_[1]};                           # desreferenciem els parmetres entrats en la funci
my @vseq2 = @{$_[2]};                           #  i els assignem a variables
my %substitucio = %{$_[3]};                     #
my $id1 = $_[4];                                    
my $id2 = $_[5];
my $i;                                          # declarem variables que usarem al llarg de la funci
my $j;                                          #

my $un = scalar (@vseq1);                       # enregistrem en una variable el nombre d'elements que 
my $dos = scalar (@vseq2);                      #  cont cada vector de les seqncies


if ($id1 =~ m/\s*>\s*([^\n]+)/) {               #
  $id1 = $1;                                    # en cas de que l'identificador de la seqncia tingui
}                                               #  en la primera posici el smbol '>', l'eliminem
                                                #
if ($id2 =~ m/\s*>\s*([^\n]+)/) {               #
  $id2 = $1;                                    #
}                                               # 


$i = $un - 1;                                   # inicialitzem les variables $i i $j per poder recuperar
$j = $dos - 1;                                  #  l'aliniament des del final al principi de la matriu

my @sortida1;                                   #
my @sortida2;                                   # declarem els tres vectors que mostrarem finalment
my @simbols;                                    #
my $p = 0;              

print "\nALINEAMENT OPTIM:\t";

while ($i > 0 || $j > 0) {
                                                 # si la puntuacio maxima venia de la diagonal 
                                                 #  alineem el simbol $i de $vseq1 amb el 
                                                 #  simbol $j de $vseq2
        if ($mrecuperacio[$i][$j][1] eq 'D')
	    
	        { 	
	        
		$sortida1[$p] = $vseq1[$i];
                $sortida2[$p] = $vseq2[$j];
                if ($sortida1[$p] eq $sortida2[$p]) {                       #
        	    $simbols[$p] = "*";                                     # segons la parella d'aminocids de
                }elsif ($substitucio{$sortida1[$p]}{$sortida2[$p]} > 0){    #  l'aliniament ptim posarem '*' si
		    $simbols[$p] = ":";                                     #  idntics o ':' si sn diferents per
		}elsif ($substitucio{$sortida1[$p]}{$sortida2[$p]} <= 0) {  #  la seva puntuaci s major que 0
                    $simbols[$p] = " ";                                     #
		}                                                           #
		
	  	$i = $i - 1;
                $j = $j - 1;
                $p = $p + 1;
	        }
                                                 # si la puntuacio venia d'amunt alineem el 
                                                 #  simbol $i de $vseq1 amb un gap
        elsif ($mrecuperacio[$i][$j][1] =~m/A(\d+)/) # l'expressi regular ens encaixa amb les 
	                                             #  posicions que comencin amb A seguida d'un
	        {                                    #  o ms dgits
		    my $long_salt = $1;                #
		    my $k = 0;                         #
		    while ( $k < $long_salt) {         #
                                                       # anem omplint els vectors de sortida
		    $sortida1[$p + $k] = $vseq1[$i-$k];#  considerant les llargades de salt que   
		    $sortida2[$p+$k] = "-";            #  hem introduit mitjanant la variable
		    $simbols[$p+$k] = " ";             #  $long_salt
		    $k = $k + 1;                       #
		}                                      #
		$i = $i - 1;                           #
		$p = $p + 1;                           #
	        }                                      #

                                                 # sino es que la puntuacio venia de l'esquerra,
                                                 #  llavors alineem gap 
                                                 #  amb el simbol $j de $vseq2
       elsif ($mrecuperacio[$i][$j][1] =~m/E(\d+)/)  # l'expressi regular ens encaixa les posicions
           {                                         #  que comencin amb E seguida d'un o ms dgits
	 my $long_salt = $1;  
	 my $k = 0;
		while ($k < $long_salt) {               #
		    $sortida2[$p+$k] = $vseq2[$j - $k]; # anem omplint els vectors de sortida 
		    $sortida1[$p+$k] = "-";             #  considerant les llargades de salt que 
		    $simbols[$p+$k] = " ";              #  hem introduit mitjanant la variable 
		    $k = $k + 1;                        #  $long_salt
                    }                                   #
                $j = $j - 1;                            #
                $p = $p + 1;                            #
                }
        
   
}

@sortida1 = reverse(@sortida1);                  #
@sortida2 = reverse(@sortida2);                  # fem l'invers dels 3 vectors finals
@simbols = reverse(@simbols);                    #

my $maxl;                             # variable per enregistrar l'identificador de la seqncia ms llarga
my $espid1;                           # ficarem el nombre d'espais que falten per arribar 
my $espid2;                           #  a la llargada de l'identificador ms llarg

my $q = 0;                                       #
my $r = 0;                                       # declarem les variables que necessitarem per recrrer els vectors
my $p = 0;                                       #  de sortida i smbols
my $s = 0;                                       #

# fiquem a $maxl la longitut de
# l'identificador mes llarg

my $i = 0;                                       #
my $sumaast = 0;                                 # declarem les variables que necessitarem per calcular la similaritat
my $sumapunts = 0;                               #  i la identitat
my $identitat;                                   #
my $similaritat;                                 #

while ($i < scalar(@simbols)) {                                   #
    if ($simbols[$i] eq '*') {                                    #
	$sumaast = $sumaast + 1;                                  # calculem la similaritat i la identitat entre 
    }elsif ($simbols[$i] eq ':') {                                #  les dues seqncies a partir del vector @smbols, 
	$sumapunts = $sumapunts + 1;                              #  on hi ha indicat si els aa de cada parella 
    }                                                             #  sn idntics o similars
    $i = $i + 1;                                                  #
}                                                                 # finalment ho enregistrem com a tant per cent
$identitat = ($sumaast/scalar(@simbols)) * 100;                   # 
$similaritat = (($sumapunts + $sumaast)/scalar(@simbols)) * 100;  #


my $score = $mrecuperacio[scalar (@vseq1) - 1][scalar (@vseq2) - 1][0]; 
printf "\tEl %% d'identitat s: %.2f%%\n",$identitat;               # mostrem per pantalla els valors de
printf "\t\t\t\tEl %% de similaritat s: %.2f%%\n",$similaritat;    # similaritat, identitat i score
print "\t\t\t\tScore: $score\n";                                    #

if ((length($id1)) > (length($id2))) {                            #
    $maxl = $id1;                                                 # mirem quina seqncia t l'identificador ms gran
}else{                                                            #  per tal de poder posar aquest identificador a
    $maxl = $id2;                                                 #  l'inici de cada lnia de l'aliniament resultant
}                                                                 #  i que els tres vectors de sortida apareixin
$espid1 = length($maxl) - length($id1);                           #  ben aliniats un sota l'altre
$espid2 = length($maxl) - length($id2);                           #

while ($q < scalar(@sortida1 )) {                                 #
                                                                  #
   print "\n$id1",' ' x $espid1,"   ";                            #
                                                                  #
   while  ($r < $q + 50)  {                                       # mostrem per pantalla l'aliniament ptim en blocs
	print "$sortida1[$r]";                                    #  de 50 aminocids posant a l'inici de cadascuna
	$r = $r + 1;                                              #  de les seqncies el seu identificador
    }                                                             #
                                                                  #
   print "\n$id2",' ' x $espid2,"   ";                            #
                                                                  #
   while ($p < $q + 50 ) {                                        #
       print "$sortida2[$p]";                                     #
       $p = $p + 1;                                               #
        }                                                         #
                                                                  #
    print "\n",' ' x length($maxl),"   ";                         #
                                                                  #
   while ($s < $q + 50)  {                                        #
       print "$simbols[$s]";                                      #
       $s = $s + 1;                                               #
        }                                                         #
                                                                  #
    print "\n";                                                   #
	$q = $q + 50;                                             #
    }                                                             #
                                                                  #
}                                                                 #
# NOM: gaps_esquerra
# PROPSIT: Donats uns parmetres, anar mirant quina ser la puntuaci mxima considerant totes les
# des de la posici on ens trobem fins l'inici de la fila
# PARMETRES: primer --> Posici de la fila 
#             segon  --> Posici de la columna
#             tercer --> Matriu d'aliniament
#             quart  --> Penalitzaci per obertura de gap
#             cinqu --> Penalitzaci per extensi de gap
#             sis   --> Matriu dels salts de l'esquerra
#RETORNA: El valor mxim per comparar-lo amb les altres dues posicions i tamb el nmero d'extensions
#         de gap que ha realitzat 
sub gaps_esquerra {

my $i = $_[0];                     #
my $j = $_[1];                     #
my @matriu = @{$_[2]};             # desreferenciaci si s necessari dels parmetres introduits en la
my $pen_obrir = $_[3];             #  funci
my $pen_ext = $_[4];
my @g_es = @{$_[5]};






if (($g_es[$i][$j-1][0] + $pen_ext) > ($matriu[$i][$j-1] + $pen_obrir)) {  # 
                                                                           # Anem considerant gaps de
    return ($g_es[$i][$j-1][0] + $pen_ext, $g_es[$i][$j-1][1] + 1);        #  diferents longituds i ens
    }                                                                      #  quedem amb el que ens dna
else {                                                                     #  una millor puntuaci
    return ($matriu[$i][$j-1] + $pen_obrir, 1);                            #
    }                                                                      #
}                                                                          #




# NOM: gaps_amunt
# PROPSIT: Donats uns parmetres, anar mirant quina ser la puntuaci mxima considerant totes les
# des de la posici on ens trobem fins l'inici de la columna
# PARMETRES: primer --> Posici de la fila 
#             segon  --> Posici de la columna
#             tercer --> Matriu d'aliniament
#             quart  --> Penalitzaci per obertura de gap
#             cinqu --> Penalitzaci per extensi de gap
#             sis   --> Matriu dels salts d'amunt 
#RETORNA: El valor mxim per comparar-lo amb les altres dues posicions i tamb el nmero d'extensions
#         de gap que ha realitzat 
sub gaps_amunt {

my $i = $_[0];                #
my $j = $_[1];                #
my @matriu = @{$_[2]};        # desreferenciaci si s necessari dels parmetres que li hem introduit
my $pen_obrir = $_[3];        #  a la funci
my $pen_ext = $_[4];          #
my @g_am = @{$_[5]};                         

if (($g_am[$i-1][$j][0] + $pen_ext) > ($matriu[$i-1][$j] + $pen_obrir)) {  #
                                                                           #
    return ($g_am[$i-1][$j][0] + $pen_ext, $g_am[$i-1][$j][1] + 1);        # Anem considerant les diferents
    }                                                                      #  longituds i ens quedem amb
else {                                                                     #  el que ens dna una millor
    return ($matriu[$i-1][$j] + $pen_obrir, 1);                            #  puntuaci
    }                                                                      #
                                                                           #
}                                                                          #

 


